// EE231002 Lab10. Word Processing
// 108061126, 王亮凱 
// 2019/11/25

#include <stdio.h>
#include <string.h>

#define PN 1000
#define PW 80
#define LN 52
#define CW 40

int read(char para[PN]);
void paragraph(char para[PN], char outBuffer[LN][CW]);
void clear(char para[PN], char outBuffer[LN][CW]);

int main(void)
{
	char para[PN] = "\0";		// input paragraph
	char outBuffer[LN][CW];// output buffer, LN lines with CW chars
	char title[3][39];			// array to store title
	int i = 0, k, ind;			// array index
	int n = 0;					// integer used to store character by ASCII 
	int len;					// the length of string
	int j;
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 39; j++) { 
			title[i][j] = '\0';
		}
	}
	for (i = 0; i < LN; i++) {
		for (j = 0; j < CW; j++) {
			outBuffer[i][j] = '\0';
		}
	}
	for (i = 0; i < LN; i++)
		printf("%s1\n", outBuffer[i]);

	for (i = 0; i < 3; i++) {	// in the title three line
		n = 0;					// initialize n
		for (k = 0; n != '\n'; k++) {	// from character to \n
			scanf("%c", &title[i][k]);		// get title
			n = title[i][k];			// save character in n
		}
		len = strlen(title[i]) - 1;		// save length in len
		for (ind = 0; ind < (PW - len) / 2; ind++) {	// do PW - len times 
			printf(" ");		// output blank space
		}
		k = 0;				// initial k to 0
		do {
			printf("%c", title[i][k]);		// output the title
			n = title[i][k];	// save character in n
			k++;			// next k
		} while(n != '\n');		// when n != \n
	}
	paragraph(para, outBuffer);		
		// to the paragraph function to fill outBuffer with para and output 
	
	return 0;
}

// fill the words of a paragraph into para
int read(char para[PN])
{	
	int i = 0;		// array index
	char n;			// integer used to store character by ASCII
	while ((n = getchar()) != '\n'){	
		// save character to n and check whether n is \n
		if (n == EOF) return 0;		// when detect EOF, return 0
			para[i] = n;			// save character in n to para
			i++;					// next indext of array
	}
	return 1;				// if there's no EOF, return 1
}
	
// function to fill outBuffer with para and output the article	
void paragraph(char para[PN], char outBuffer[LN][CW])
{
	int end;			// integer to indicate status of paragraph
	int add;			// integer used to find blank space in para
	int ind = 0;		// array index in para
	int remain;			// chracter number left in string
	int i, j = 0, k;		// array index
	unsigned int space;		// loop index

	end = read(para);	// save return value of read to end
	remain = strlen(para);		// save string length to remain
	
	while (remain > CW) {		// when remain > CW
		add = CW - 2;				// initialize add
		while (para[ind + add] != ' ') add--;		// find largest add
		for (k = 0; k <= add; k++) {				// k from 0 to add
			outBuffer[j][k] = para[ind++];			// copy para to outBuffer
			remain--;			// remain - 1 when save a characer to outBuffer
		}
		outBuffer[j][k] = '\0';		// store \0 to end of outBuffer
		j++;				// next row
	}	
	for (k = 0; k < remain; k++) {		// when remain < CW
		outBuffer[j][k] = para[ind++];		// save para to outBuffer
	}
	
	for (i = 0; i < j / 2 + 1; i++) {	// do j / 2 + 1 times
		if(*outBuffer[i] == '\0') printf("\n");		
			// when there's nothing in outBuffer 
		else {			// when there's words in outBuffer
			for (space = 0; space < PW / 2 - strlen(outBuffer[i]); space++)
				printf(" ");	
				 	// print the blank space before outBuffer
			printf("%s", outBuffer[i]);		// print the left outBuffer
			printf("| ");					// print |
			printf("%s\n", outBuffer[i + j / 2 + 1]);	
				// print the right outBuffer
		}
	}
	clear(para, outBuffer);			// clear para and outBuffer
	if (end) paragraph(para, outBuffer);	
		// if not dectect EOF, go to next paragraph
}

// clear para and outBuffer
void clear(char para[PN], char outBuffer[LN][CW])
{
	int i, j;			// loop index
	for(i = 0; i < LN; i++){	// every row
		for(j = 0; j < CW; j++){		// every column
			outBuffer[i][j] = '\0';		// clear the character stored in para
		}
	}
	for(i = 0; para[i] != '\n'; i++){	// from the first character to the last
		para[i] = '\0';		// clear the character stored in para
	}
}
